/**
* \file *********************************************************************
*
* \brief  œK቞p : main.c
*
*      ̗ł͓͂̎悷̂1ADCقgA5bɌʂUSART
*      ʂđo܂BADČʂ͈͊ȌꍇApُԂŌŒ艻
*      O30bԁAx񂪑o܂BJԂ̎cł޲
*      ܰޓɒu܂B
*
* \par pLq:
*      AVR4027: 8ޯAVRpCލœK̂߂̏Ɣ錍
*
* \par ߲	: AVR GCC 8ޯ °
* \par 		: gcc 4.5.1
*
* \author
*      Atmel Corporation: http://www.atmel.com \n
*      xEҰ: avr@atmel.com
*
* $Revision$
* $Date$  \n
*
* 쌠 (C) 2011 Atmel Corporation. s
*
* \page 
*

* ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
* ΋܂B
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*    Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*    (ۏ)ɎgpłȂ܂B
*
* 4. ̿ĳAtmelAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂAtmel̂悤ȑQ̉\iꂽƂ
* ĂA{gpłȂA܂͎gpȊOŔ(̑AƒfA
* ͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRARAʁA
* ܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔCȂł傤B
*****************************************************************************/

#include "adc.h"
#include "usart.h"
#include "tc2_asyn.h"
#include "ADC_to_USART.h"
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>

char error[] = {" ERROR"};
char hot[] = {" HOT"};
char cool[] = {" COOL"};
uint8_t adc_cnt = 0;
uint8_t adc_sum[ADC_NUM]= {0};
uint8_t cycle_cnt = 0;

int main()
{
	power_reduce();			// ߓd̂ߖgpPʕdf
	io_init();				// o߰ď
	adc_init();				// ADCPʕƏ
	usart_init();			// USART
	tc2_asyn_init();		// v2񓯊ŏ
	sei();					// S̊荞݋

	while(1) {
		set_sleep_mode (SLEEP_MODE_PWR_SAVE);	// v2ꊄ荞݂N܂CPUx~
		sleep_mode();
		PIND |= 1<<PIND0;						/* JԂJn߂݌ݐ؂ւ */

		if ( cycle_cnt > ALARM_N){
			USART0_Transmit_String(error);
		} else {
			// ADCʎ擾Ȁ݂Ԃ𔻒f
			uint8_t temp = adc_to_buffer();
			if (temp > ADC_TOP){
				USART0_Transmit_String(hot);
				cycle_cnt++;
			} else if (temp < ADC_BOT){
				USART0_Transmit_String(cool);
				cycle_cnt++;
			} else {
				adc_sum[adc_cnt++] = temp;
				cycle_cnt = 0;
			}
		}
		// h߂ADCʎ擾AUSARTʂđo
		if (adc_cnt >= ADC_NUM) {
			adc_cnt = 0;
			USART0_Transmit( adc_filter_mid(adc_sum, ADC_NUM) );
		}
		PIND |= 1<<PIND0;						/* JԂI߂݌ݐ؂ւ */
	}
}

/* lgƂɂADCʂh */
uint8_t adc_filter_mid(uint8_t *buffer, uint8_t buffer_cnt)
{
	for (uint8_t i = 0; i < buffer_cnt ; i++) {
		for (uint8_t j = 0; j < buffer_cnt ; j++) {
			if (buffer[j] < buffer[j+1]) {
				uint8_t temp;
				temp = buffer[j+1];
				buffer[j+1] = buffer[j];
				buffer[j] = temp;
			}
		}
	}
	return buffer[buffer_cnt>>1];
}

/* TC2ꊄ荞 */
ISR (TIMER2_OVF_vect)
{
	TIFR2 |= 1<<TOV2;
}
